// eslint-disable-next-line no-undef
const useLocalhost = process && process.env.NODE_ENV === 'development'
// eslint-disable-next-line no-undef
const domain = process && process.env.NEXT_PUBLIC_DOMAIN

if (!domain && !useLocalhost) {
    throw new Error(
        'Domain is not defined! Please set NEXT_PUBLIC_DOMAIN env variable!'
    )
}

const constants = {
    domain: domain || 'localhost',
    siteUrl: useLocalhost ? 'http://localhost:8080/' : `https://${domain}/`,
    apiUrl: useLocalhost
        ? 'http://localhost:8080/api/'
        : `https://${domain}/api/`,
    maxQuestionsToRender: 250,
}

export default constants
